import usb
import os
import time
import sys
from board import *

###################
### Define Part ###
###################

#key config
KEY_PRESSED = ['xte "keydown q"','xte "keydown w"','xte "keydown e"','xte "keydown t"','xte "keydown y"']
KEY_UNPRESSED = ['xte "keyup q"','xte "keyup w"','xte "keyup e"','xte "keyup t"','xte "keyup y"']

#using USB board
board = Board()
key = [[],[],[],[],[]]

#on-off button
light5 = 512
power_on = False

############
### Main ###
############
#check if it pressed
while(True):
	#check if pressed the open button (PC5)
	light5 = board.get_light5()
	if(light5 < 100):
		power_on = True
		#open zynaddsubfx using unix command
		os.system('zynaddsubfx -L sound.xiz &')
		print("Loading ZynAddSubFX...")
		while(power_on):
			#check key0-4 (PC0-4)
			for x in range(0,5):
				if(x==0):
					key[x] = board.get_light0()
				elif(x==1):
					key[x] = board.get_light1()
				elif(x==2):
					key[x] = board.get_light2()
				elif(x==3):
					key[x] = board.get_light3()
				elif(x==4):
					key[x] = board.get_light4()	
				for x in range(0,5):
					if(key[x] < 250):
						os.system(KEY_PRESSED[x])
					else:
						os.system(KEY_UNPRESSED[x])
				#power off if press PC5 longer than 1 seconds
				if(board.get_light5() < 50):
					for sec in range(0,2):
						time.sleep(0.5)
						if(board.get_light5() > 50):
							power_on = True
							break
						else:
							print "Exit ZynAddSubFX"
							power_on = False
							os.system("xte 'keydown Alt_L' 'key F4' 'usleep 10000' 'keyup Alt_L' 'usleep 10000' 'keydown Return' 'usleep 10000' 'keyup Return'")
							print "Script Exit"
							sys.exit()
